Package: docopt
Type: Package
Title: Command-Line Interface Specification Language
Version: 0.7.2
Authors@R: c(
  person("Edwin", "de Jonge", email = "edwindjonge@gmail.com", role = c("aut", "cre"), 
    comment=c(ORCID="0000-0002-6580-4718")))
Maintainer: Edwin de Jonge <edwindjonge@gmail.com>
Description: Define a command-line interface by just giving it
    a description in the specific format.
License: MIT + file LICENSE
URL: https://github.com/docopt/docopt.R
BugReports: https://github.com/docopt/docopt.R/issues
Imports: methods
Suggests: testthat
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-03-25 21:06:03 UTC; edwin
Author: Edwin de Jonge [aut, cre] (<https://orcid.org/0000-0002-6580-4718>)
Repository: CRAN
Date/Publication: 2025-03-25 21:30:06 UTC
Built: R 4.6.0; ; 2026-04-25 18:21:06 UTC; unix

Package: docopt
Type: Package
Title: Command-Line Interface Specification Language
Version: 0.7.2
Authors@R: c(
  person("Edwin", "de Jonge", email = "edwindjonge@gmail.com", role = c("aut", "cre"), 
    comment=c(ORCID="0000-0002-6580-4718")))
Maintainer: Edwin de Jonge <edwindjonge@gmail.com>
Description: Define a command-line interface by just giving it
    a description in the specific format.
License: MIT + file LICENSE
URL: https://github.com/docopt/docopt.R
BugReports: https://github.com/docopt/docopt.R/issues
Imports: methods
Suggests: testthat
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-03-25 21:06:03 UTC; edwin
Author: Edwin de Jonge [aut, cre] (<https://orcid.org/0000-0002-6580-4718>)
Repository: CRAN
Date/Publication: 2025-03-25 21:30:06 UTC

Docopt for Rust with automatic type based decoding (i.e., data validation).
This implementation conforms to the
[official description of Docopt](http://docopt.org/) and
[passes its test suite](https://github.com/docopt/docopt/pull/201).

[![Build status](https://api.travis-ci.org/docopt/docopt.rs.svg)](https://travis-ci.org/docopt/docopt.rs)

Licensed under the [UNLICENSE](http://unlicense.org).


### Current status

Fully functional but the design of the API is up for debate. **I am seeking
feedback**.


### Documentation

[http://burntsushi.net/rustdoc/docopt](http://burntsushi.net/rustdoc/docopt/index.html)


### Installation

This crate is fully compatible with Cargo. Just add it to your `Cargo.toml`:

```toml
[dependencies]
docopt = "*"
```

If you want to use the macro (which won't work when Rust 1.0 stable is
released, but will continue to work on the nightlies), then use `docopt_macros
= "*"` instead.


### Quick example

Here is a full working example:

```rust
extern crate "rustc-serialize" as rustc_serialize;
extern crate docopt;

use docopt::Docopt;

// Write the Docopt usage string.
static USAGE: &'static str = "
Usage: cp [-a] <source> <dest>
       cp [-a] <source>... <dir>

Options:
    -a, --archive  Copy everything.
";

#[derive(RustcDecodable, Show)]
struct Args {
    arg_source: Vec<String>,
    arg_dest: String,
    arg_dir: String,
    flag_archive: bool,
}

fn main() {
    let args: Args = Docopt::new(USAGE)
                            .and_then(|d| d.decode())
                            .unwrap_or_else(|e| e.exit());
    println!("{:?}", args);
}
```

Here is the same example, but with the use of the `docopt!` macro, which will
*generate a struct for you*:

```rust
#![feature(plugin)]

extern crate "rustc-serialize" as rustc_serialize;

extern crate docopt;
#[plugin] #[no_link] extern crate docopt_macros;

docopt!(Args derive Show, "
Usage: cp [options] <src> <dst>
       cp [options] <src>... <dir>
       cp --help

Options:
  -h, --help       Show this message.
  -a, --archive    Copy everything.
");

fn main() {
    let args: Args = Args::docopt().decode().unwrap_or_else(|e| e.exit());
    println!("{:?}", args);
}
```

The field names of the struct map like this:

```
-g       => flag_g
--group  => flag_group
FILE     => arg_FILE
<file>   => arg_file
build    => cmd_build
```

The `Args` struct has one static method defined for it: `docopt`. The method
returns a normal `Docopt` value, which can be used to set configuration
options, `argv` and parse or decode command line arguments.


### Data validation example

Here's another example that shows how to specify the types of your arguments:

```rust
#![feature(plugin)]

extern crate "rustc-serialize" as rustc_serialize;

extern crate docopt;
#[plugin] #[no_link] extern crate docopt_macros;

docopt!(Args, "Usage: add <x> <y>", arg_x: usize, arg_y: usize);

fn main() {
    let args: Args = Args::docopt().decode().unwrap_or_else(|e| e.exit());
    println!("x: {}, y: {}", args.arg_x, args.arg_y);
}
```

In this example, specific type annotations were added. They will be
automatically inserted into the generated struct. You can override as many (or
as few) fields as you want. If you don't specify a type, then one of `bool`,
`uint`, `String` or `Vec<String>` will be chosen depending on the type of
argument. In this case, both `arg_x` and `arg_y` would have been `String`.

If any value cannot be decoded into a value with the right type, then an error
will be shown to the user.

And of course, you don't need the macro to do this. You can do the same thing
with a manually written struct too.


### Modeling `rustc`

Here's a selected subset for some of `rustc`'s options. This also shows how to
restrict values to a list of choices via an `enum` type and demonstrates more
Docopt features.

```rust
#![feature(plugin)]

extern crate "rustc-serialize" as rustc_serialize;

extern crate docopt;
#[plugin] #[no_link] extern crate docopt_macros;

docopt!(Args derive Show, "
Usage: rustc [options] [--cfg SPEC... -L PATH...] INPUT
       rustc (--help | --version)

Options:
    -h, --help         Show this message.
    --version          Show the version of rustc.
    --cfg SPEC         Configure the compilation environment.
    -L PATH            Add a directory to the library search path.
    --emit TYPE        Configure the output that rustc will produce.
                       Valid values: asm, ir, bc, obj, link.
    --opt-level LEVEL  Optimize with possible levels 0-3.
", flag_opt_level: Option<OptLevel>, flag_emit: Option<Emit>);

#[derive(RustcDecodable, Show)]
enum Emit { Asm, Ir, Bc, Obj, Link }

#[derive(Show)]
enum OptLevel { Zero, One, Two, Three }

impl rustc_serialize::Decodable for OptLevel {
    fn decode<D: rustc_serialize::Decoder>(d: &mut D) -> Result<OptLevel, D::Error> {
        Ok(match try!(d.read_usize()) {
            0 => OptLevel::Zero, 1 => OptLevel::One,
            2 => OptLevel::Two, 3 => OptLevel::Three,
            n => {
                let err = format!("Could not decode '{}' as opt-level.", n);
                return Err(d.error(&*err));
            }
        })
    }
}

fn main() {
    let args: Args = Args::docopt().decode().unwrap_or_else(|e| e.exit());
    println!("{:?}", args);
}
```

### Viewing the generated struct

Generating a struct is pretty magical, but if you want, you can look at it by
expanding all macros. Say you wrote the above example for `Usage: add <x> <y>`
into a file called `add.rs`. Then running:

```bash
rustc -L path/containing/docopt/lib --pretty expanded add.rs
```

Will show all macros expanded. In the generated code, you should be able to
find the generated struct:

```rust
struct Args {
    pub arg_x: int,
    pub arg_y: int,
}
```


### Traditional Docopt API

The reference implementation of Docopt returns a Python dictionary with names
like `<arg>` or `--flag`. If you prefer this access pattern, then you can use
`docopt::ArgvMap`. The disadvantage is that you have to do all of your type
conversion manually. Here's the canonical Docopt example with a hash table:

```rust
extern crate docopt;

use docopt::Docopt;

static USAGE: &'static str = "
Naval Fate.

Usage:
  naval_fate.py ship new <name>...
  naval_fate.py ship <name> move <x> <y> [--speed=<kn>]
  naval_fate.py ship shoot <x> <y>
  naval_fate.py mine (set|remove) <x> <y> [--moored | --drifting]
  naval_fate.py (-h | --help)
  naval_fate.py --version

Options:
  -h --help     Show this screen.
  --version     Show version.
  --speed=<kn>  Speed in knots [default: 10].
  --moored      Moored (anchored) mine.
  --drifting    Drifting mine.
";

fn main() {
    let args = Docopt::new(USAGE)
                      .and_then(|dopt| dopt.parse())
                      .unwrap_or_else(|e| e.exit());
    println!("{:?}", args);

    // You can conveniently access values with `get_{bool,count,str,vec}`
    // functions. If the key doesn't exist (or if, e.g., you use `get_str` on
    // a switch), then a sensible default value is returned.
    println!("\nSome values:");
    println!("  Speed: {}", args.get_str("--speed"));
    println!("  Drifting? {}", args.get_bool("--drifting"));
    println!("  Names: {:?}", args.get_vec("<name>"));
}
```

### Tab completion support

This particular implementation bundles a command called `docopt-wordlist` that
can be used to automate tab completion. This repository also collects some
basic completion support for various shells (currently only bash) in the
`completions` directory.

You can use them to setup tab completion on your system. It should work with
any program that uses Docopt (or rather, any program that outputs usage
messages that look like Docopt). For example, to get tab completion support for
Cargo, you'll have to install `docopt-wordlist` and add some voodoo to your
`$HOME/.bash_completion` file (this may vary for other shells).

Here it is step by step:

```bash
# Download and build `docopt-wordlist` (as part of the Docopt package)
$ git clone git://github.com/docopt/docopt.rs
$ cd docopt.rs
$ cargo build --release

# Now setup tab completion (for bash)
$ echo "DOCOPT_WORDLIST_BIN=\"$(pwd)/target/release/docopt-wordlist\"" >> $HOME/.bash_completion
$ echo "source \"$(pwd)/completions/docopt-wordlist.bash\"" >> $HOME/.bash_completion
$ echo "complete -F _docopt_wordlist_commands cargo" >> $HOME/.bash_completion
```

My [CSV toolkit](https://github.com/BurntSushi/xsv) is supported too:

```bash
# shameless plug...
$ echo "complete -F _docopt_wordlist_commands xsv" >> $HOME/.bash_completion
```

Note that this is emphatically a first pass. There are several improvements
that I'd like to make:

1. Take context into account when completing. For example, it should be
   possible to only show completions that can lead to a valid Docopt match.
   This may be hard. (i.e., It may require restructuring Docopt's internals.)
2. Support more shells. (I'll happily accept pull requests on this one. I doubt
   I'll venture outside of bash any time soon.)
3. Make tab completion support more seamless. The way it works right now is
   pretty hacky by intermingling file/directory completion.

Pattern <- setRefClass( "Pattern"   
      , fields=list(children="list")
      , methods=list(
        initialize = function(.children=list()){
            children <<- .children
          },
        toString = function(){
          formals = paste0(sapply(children, as.character), collapse=", ")
          paste0(class(.self),"(",formals,")")
        },
        show = function(){
          cat(toString())
        },
  
        match = function(){
            stop("classes inheriting from Pattern
                  must overload the match method")
        },
                          
        flat = function(...){
            types = list(...)
            if (class(.self) %in% types){
              return(list(.self))
            }
            if (length(children) == 0){
              return(list(.self))
            }
            unlist(lapply(children, function(child){child$flat(...)}))
          },
  
        fix = function(){
          fix_identities()
          fix_repeating_arguments()
        },
        #Make pattern-tree tips point to same object if they are equal.
        fix_identities = function(uniq=NULL){
          #browser()
          if (length(children) == 0) {
            return(.self)
          }
          if (is.null(uniq)){
            uniq <- flat()
            names(uniq) <- sapply(uniq, as.character)
          }
          for (i in seq_along(children)){
            child <- children[[i]]
            if (length(child$children)){
              #TODO check what uniq does.
              child$fix_identities(uniq)
            } else {
              children[[i]] <<- uniq[[child$toString()]]
            }
          }
          uniq
        },
#       Find arguments that should accumulate values and fix them.
        fix_repeating_arguments = function(){
          eith <- lapply(either()$children, function(c) c$children)
          for (child in eith){
            nms <- as.character(sapply(child, as.character))
            #browser()
            counts <- table(nms)
            for (e in child){
              if (isTRUE(unname(counts[as.character(e)] > 1))){
                if (class(e)=="Argument" ||(class(e)=="Option" && e$argcount>0)){
                  if (is.null(e$value)){
                    e$value <- list()
                  } else if (class(e$value) != "list"){
                    e$value <- as.list(e$value)
                  }
                }
                if ( class(e) == "Command" 
                  || (class(e) == "Option" && e$argcount == 0)){
                   e$value <- 0L
                }
              } 
            } 
          }
          .self
        },
        either = function(){
          if (length(children) == 0L){
            return(Either(list(Required(list(.self)))))
          }
          #browser()
         ret <- list()
          #             groups = [[@]]
          groups <- list(list(.self))
#             while groups.length
          while (length(groups)){
#                 children = groups.shift()
            .children <- head(groups, 1)[[1]]
            groups <- tail(groups, -1)
            type <- c("Either", "Required","Optional", "OneOrMore", "AnyOptions")
            childtype <- sapply(.children, class)
            m <- base::match(childtype, type, nomatch=0L)
            
            if (any(m > 0)){
              # take first child bigger than zero
              idx <- which(m > 0L)[1]
              child <- .children[[idx]]
              .children <- .children[-idx]
              if (class(child) == "Either"){
                for (ci in child$children){
                  group <- c(ci, .children)
                  groups[[length(groups)+1]] <- group
                }
              } else if (class(child) == "OneOrMore"){
                group <- c(child$children, child$children, .children)
                groups[[length(groups)+1]] <- group
              } else {
                group <- c(child$children, .children)
                groups[[length(groups)+1]] <- group                
              }
            } else{
              ret[[length(ret)+1]] <- .children
            }
          }
          Either(lapply(ret, function(e) Required(e)))
        }
))

# LeafPattern <- setRefClass( "LeafPattern"   
#   , fields=c("name", "value")
#   , methods=list(
#       flat = function(...){
#         types <- list(...)
#         if (length(l)==0 || class(.self) %in% types){
#           return(list(.self))
#         }
#         list()
#       },
#       match = function(left, collected=list()){
#         browser()
#         m <- single_match(left)
#         # if match is None:
#         #   return False, left, collected
#         if (is.null(m$match)){
#           return(matched(FALSE, left, collected))
#         }
#         # left_ = left[:pos] + left[pos + 1:]
#         left_ <- left[-m$pos]
#         # same_name = [a for a in collected if a.name == self.name]
#         same_name <- Filter(function(a){a$name == name}, collected)
#         # if type(self.value) in (int, list):
#         if (class(value) %in% c("integer", "list")){
#           browser()
#         #   if type(self.value) is int:
#           if (is.integer(value)){
#         #   increment = 1
#             increment <- 1
#           } else {
#         # else:
#         #   increment = ([match.value] if type(match.value) is str
#         #                else match.value)
#             increment <- m$match$value
#             if (is.character(increment)){
#               increment <- list(increment)
#             }
#           }
#           # if not same_name:
#           if (length(same_name)==0){
#             #   match.value = increment
#             match$value <- increment
#             # return True, left_, collected + [match]
#             return(matched(TRUE, left_, c(collected, match)))
#           }
#           val <- same_name[[1]]$value
#           # same_name[0].value += increment
#           # return True, left_, collected
#           same_name[[1]]$value <- if (is.integer(val)) val + increment else c(val, increment)
#           return(matched(TRUE, left_, collected))
#         }
#         # return True, left_, collected + [match]        
#         return(matched(TRUE, left_, c(collected, match)))
#       }
#     )
#   )
# BranchPattern <- setRefClass("BranchPattern", contains="Pattern"
#     , methods=list(
#       initialize = function(.children=list()){
#         children <<- .children
#       },
#       flat=function(...){
#         types <- list(...)
#         if (class(.self) %in% types){
#           return(list(.self))
#         }        
#         if (length(children) == 0){
#           return(list())
#         }
#         unlist(lapply(children, function(child){child$flat(...)}))
#       }
#     )
# )
# 
# class BranchPattern(Pattern):
#   
#   """Branch/inner node of a pattern tree."""
# 
# def __init__(self, *children):
#   self.children = list(children)
# 
# def __repr__(self):
#   return '%s(%s)' % (self.__class__.__name__,
#                      ', '.join(repr(a) for a in self.children))
# 
# def flat(self, *types):
#   if type(self) in types:
#   return [self]
# return sum([child.flat(*types) for child in self.children], [])

# class Argument extends Pattern
Argument <- setRefClass("Argument", contains="Pattern"
                       , fields = c("argname", "value")
                       , methods = list(
                         initialize=function(argname, value=NULL){
                           argname <<- argname
                           value <<- value
                         },                           
# 
#     name: -> @argname
                         name = function(){
                           argname
                         },
#     toString: -> "Argument(#{@argname}, #{@value})"
                         toString = function(){
                           paste0("Argument(",argname,",",value,")")
                         },
#     match: (left, collected=[]) ->
       match = function(left, collected=list()){
         #         args = (l for l in left when l.constructor is Argument)
         argsidx <- which(sapply(left, class) == "Argument")
         arg <- head(argsidx,1)       
         if (!length(arg)){
           return(matched(FALSE, left, collected))
         }
         arg <- left[[arg]]
         left <- Filter(function(l){!identical(l, arg)}, left)
         if (is.null(value) || !is.list(value)){
           collected <- c(collected, list(Argument(name(), arg$value)))
           return(matched(TRUE, left, collected))
         }
         same_name <- Filter(function(a){
                               class(a) == "Argument" && identical(a$name(), name())
                             }
                            , collected)
         if (length(same_name)){
           same_name[[1]]$value <- c(same_name[[1]]$value, arg$value)
           return(matched(TRUE, left, collected))
         } else{
           collected <- c(collected, Argument(name(), arg$value))
           return(matched(TRUE, left, collected))
         }
       }
))
# 
# 
# class Command extends Pattern
Command <- setRefClass("Command"
    , contains="Pattern"
    , fields = c("cmdname", "value")
    , methods=list(
      initialize = function(cmdname, value=FALSE){
        cmdname <<- cmdname
        value <<- value
      },
       
#     name: -> @cmdname
      name = function(){
        cmdname
      },
      toString = function(){
        paste0("Command(",cmdname,",",value,")")
      },
#     match: (left, collected=[]) ->
      match = function(left, collected=list()){
        #browser()
        argsidx <- which(sapply(left, class) == "Argument")
        firstarg <- head(argsidx,1)
        #         args = (l for l in left when l.constructor is Argument)
        #         if not args.length or args[0].value isnt @name()
        if (!length(firstarg) || left[[firstarg]]$value != name()){
        #             return [false, left, collected]{
          return(matched(FALSE, left, collected))
        }
        #         left.splice(left.indexOf(args[0]), 1)
        left <- left[-firstarg]
        #         collected.push new Command @name(), true
        collected <- c(collected, Command(name(), TRUE))
        #         [true, left, collected]
        matched(TRUE, left, collected)
      }
))
# 
# 
# class Option extends Pattern
Option <- setRefClass("Option", contains="Pattern"
                     , fields = c("short", "long", "argcount", "value", "cardinality")
                     , methods = list(
                       initialize= function(short=NULL, long=NULL, argcount=0L, value=FALSE){
                         short <<- short
                         long <<- long
                         argcount <<- argcount
                         if (argcount && missing(value)){
                           value <<- NULL
                         } else value <<- value
                         cardinality <<- 1L
                       },
                       toString = function(){
                         val <- value
                         if (length(val) > 1){
                           val <- paste0("[",paste0(val, collapse = ","),"]")
                         }
                         paste0("Option(",short,",",long,",",argcount,",", val,")")
                       },
                       name = function(){
                         if (!is.null(long)) long else short
                       },
       match = function(left, collected=list()){
         pos <- single_match(left)
         if (pos == 0){
           return(matched(FALSE, left, collected))
         }
         match = left[[pos]]
         left_ = left[-pos]
         
         same_name <- Filter( function(l) identical(name(), l$name())
                            , collected)
         if (class(value) %in% c("list", "integer")){
           
           if (is.integer(value)){
             match$value <- 1L
           }
           
           if (length(same_name)){  
             if (is.integer(value)){
               same_name[[1]]$value <- same_name[[1]]$value + match$value
             } else {
               same_name[[1]]$value <- c(same_name[[1]]$value, match$value)
             }
             #print(collected)
             return(matched(TRUE, left_, collected))
           }
         }
         #print(ls.str())
         matched(TRUE, left_, c(collected,match))
       },
       single_match = function(left){
         base::match( name()
                    , sapply(left, function(l) l$name())
                    , nomatch = 0
                    )
       }
))

# class Required extends Pattern
Required <- setRefClass("Required", contains="Pattern"
                       , methods=list(
        match = function(left, collected=list()){
          m <- matched(TRUE, left, collected)
          for (p in children){
            m <- p$match(m$left, m$collected)
            if (!m$matched){
              return(matched(FALSE, left, collected))
            }
          }
          m
        }
))
# 
# class Optional extends Pattern
Optional <- setRefClass("Optional", contains="Pattern"
                       , methods=list(
       match = function(left, collected=list()){
         m <- matched(FALSE, left, collected)
         for (p in children){
           m <- p$match(m$left, m$collected)
         }
         m$matched <- TRUE
         m
       }
))

# class AnyOptions extends Optional
AnyOptions <- setRefClass("AnyOptions", contains="Optional")

# 
# class OneOrMore extends Pattern
OneOrMore <- setRefClass("OneOrMore", contains="Pattern"
                        , methods=list(
#     match: (left, collected=[]) ->
        match = function(left, collected=list()){
          m <- matched(TRUE, left, collected)
          #         l_ = []
          l_ <- character()
          #         times = 0
          times <- 0L
          #         while matched
          while (m$matched){
          #             # could it be that something didn't match but changed l or c?
          #             [matched, l, c] = @children[0].match(l, c)
            m <- children[[1]]$match(m$left, m$collected)
          #             times += if matched then 1 else 0
            if (m$matched){
              times <- times + 1L
            }
          #             if l_.join(', ') is l.join(', ') then break
            if (identical(paste0(l_, collapse=", "), paste0(m$left, collapse=", "))){ 
              break
            }
          #             l_ = l #copy(l)
            l_ <- m$left
          }
          #         if times >= 1 then return [true, l, c]
          if (times >= 1){
            matched(TRUE, m$left, m$collected)
          } else {
            #         [false, left, collected]
            matched(FALSE, left, collected)
          }
        }
))
# 
# class Either extends Pattern
Either <- setRefClass("Either", contains="Pattern"
                         , methods=list(
#     match: (left, collected=[]) ->
       match = function(left, collected=list()){
         #         outcomes = []
         m <- matched(FALSE, left, collected)
         outcomes <- lapply(children, function(p){
           p$match(left, collected)
         })
         outcomes <- Filter(function(p){
           p$matched
         }, outcomes)
         #         if outcomes.length > 0
         if (length(outcomes)){
         #             outcomes.sort((a,b) ->
           sizes <- sapply(outcomes, function(o) length(o$left))
           #                 if a[1].length > b[1].length
           #                     1
           #                 else if a[1].length < b[1].length
           #                     -1
           #                 else
           #                     0)
           #             return outcomes[0]
           return(outcomes[[which.min(sizes)]])
         }
         #         [false, left, collected]
         matched(FALSE, left, collected)
       }
    ))

#' as.character.Pattern
#' 
#' as.character.Pattern
#' @keywords internal
setMethod("as.character", "Pattern", function(x, ...){
 x$toString() 
})

# utility function for returning a tuple of a match
matched <- function(matched, left, collected){
  list(matched=matched, left=left, collected=collected)
}


# utility function for collecting options
OptionList <- setRefClass( "OptionList"
                          , fields = list(options="list")
                          , methods=list(
  initialize = function(.options=list()){
    options <<- .options
  },
  push = function(o){
    options <<- append(options, o)
  }
))

#' Docopt command line specification
#' 
#' docopt helps you to define an interface for your command-line app, and
#' automatically generate a parser for it.
#' 
#' For more information see http://docopt.org
#' 
#' @name docopt-package
#' @importFrom utils tail str
#' @docType package
{}

#' Parse \code{args} based on command-line interface described in \code{doc}.
#' 
#' \code{docopt} creates your command-line interface based on its
#' description that you pass as \code{doc}. 
#' Such description can contain
#' --options, <positional-argument>, commands, which could be
#' [optional], (required), (mutually | exclusive) or repeated...
#' 
#' @examples
#' "Usage: my_program.R [-hso FILE] [--quiet | --verbose] [INPUT ...]
#'
#' -h --help    show this
#' -s --sorted  sorted output
#' -o FILE      specify output file [default: ./test.txt]
#' --quiet      print less text
#' --verbose    print more text" -> doc
#' docopt(doc, "-s --quiet")
#' @param doc \code{character} vector with command line specification
#' @param args \code{character} vector of commandline arguments. 
#' If \code{args} is missing 
#' \code{commandArgs(trailingOnly=TRUE)} will be used.
#' @param name Currently not used
#' @param help \code{logical} should "-h" or "--help" generate a usage string?
#' @param version \code{character}. If supplied the option "-v" generates
#' the given version number and stops.
#' @param strict \code{logical} if \code{TRUE} docopt will conform to docopt.py 
#' in and output (\code{strip_names=FALSE} and \code{quoted_args=FALSE})
#' @param strip_names if \code{TRUE} it will remove dashes and angles from the 
#' resulting names and add these to the resulting list. 
#' Note that this is different from docopt standard! 
#' @param quoted_args if \code{TRUE} it will accept quoted arguments. 
#' Note that this is different from docopt standard! 
#' @return named list with all parsed options, arguments and commands.
#' @references \url{http://docopt.org},
#' @export
#' @import methods
docopt <- function( doc, args=commandArgs(TRUE), name=NULL, help=TRUE, version=NULL
                  , strict=FALSE, strip_names=!strict, quoted_args=!strict
                  ){
  if (missing(args)) {
    # littler compatibility - map argv vector to args
    if (exists("argv", where = .GlobalEnv, inherits = FALSE)) {
      args = get("argv", envir = .GlobalEnv);
    } else {
			args <- quote_spaced(args)
		}
  }
  
  #print(args)
  #browser()
  #args <- fix_quoted_options(args)
  #args <- str_c(args, collapse=" ")
  
  usage <- printable_usage(doc, name)
  pot_options <- parse_doc_options(doc)
  pattern <- parse_pattern(formal_usage(usage), pot_options)
  for (anyopt in pattern$flat("AnyOptions")){
    #TODO remove options that are present in pattern
    if (class(anyopt) == "AnyOptions") anyopt$children <- pot_options$options
  }
  
  args <- parse_args(args, pot_options)
  extras(help, version, args, doc)
  m <- pattern$fix()$match(args)
  if (m$matched && length(m$left) == 0){    
    cl <- sapply(m$collected, class)
    options <- m$collected[cl == "Option"]
    
    pot_arguments <- pattern$flat()
    pot_arguments <- pot_arguments[sapply(pot_arguments, class) %in% 
                                     c("Argument", "Command")]
    
    arguments <- m$collected
    arguments <- arguments[sapply(arguments, class) %in% c("Argument", "Command")]
    dict <- list()
    class(dict) <- c("docopt", "list")
    
    for(kv in c(pot_options$options, options, pot_arguments, arguments)){
      value <- kv$value
      dict[kv$name()] <- list(value)
    }
    if (isTRUE(strip_names)){
      nms <- gsub("(^<)|(^\\-\\-?)|(>$)", "", names(dict))
      # kebab case to snake case
      nms <- gsub("-", "_", nms)
      dict[nms] <- dict
    }
    return(dict)
  }
  stop(doc, call. = FALSE)
  #stop(paste("\n",usage, collapse="\n  "), call. = FALSE)
}
         
# print help
help <- function(doc){
  cat(doc, "\n")
}
                   
#print version
version <- function(version=NULL){
  if (!is.null(version)){
    cat("Version: ", version, "\n")
  }
}

extras <- function(help, version=NULL, options, doc){
  opts <- list()
  for (opt in options){
    if (!is.null(opt$value)){
      opts[opt$name()] <- TRUE
    }
  }
  if (help && any(names(opts) %in% c("-h","--help"))){
    help <- str_replace_all(doc, "^\\s*|\\s*$", "")
    cat(help,"\n")
    if (interactive()) stop(call. = FALSE) else {
      quit(save="no")
    }
  }
  if (!is.null(version) && any(names(opts) %in% "--version")){
    cat(version)
    if (interactive()) stop(call.  = FALSE) else quit(save="no")
  }
}

printable_usage <- function(doc, name){
  usage_split <- str_split(doc, "(?i)usage:\\s*")[[1]]
  if (length(usage_split) < 2){
    stop("'usage:' (case-insensitive) not found", call. = FALSE)
  } else if (length(usage_split) > 2){
    stop('More than one "usage:" (case-insensitive).', call. = FALSE)
  }
  usage <- str_split(usage_split[2], "\n\\s*")[[1]]
  firstword <- str_extract(usage, "^\\w+")
  progs <- which(firstword == firstword[1])
  usage <- str_c("usage: ", usage[progs])
  str_trim(usage)
}

# 
formal_usage <- function(printable_usage){
# formal_usage = (printable_usage) ->
#     pu = printable_usage.split(/\s+/)[1..]  # split and drop "usage:"
#     ((if s == pu[0] then '|' else s) for s in pu[1..]).join ' '
  formal <- str_replace(printable_usage, "^usage:\\s*", "")
  pu <- unlist(str_split(formal, "\\s+"))
  prog <- pu[1]
  pu[pu==prog] <- "|"
  formal <- str_c(tail(pu, -1), collapse=" ")
  formal
}

quote_spaced <- function(x){
  ifelse( str_detect(x, "\\s")
        , shQuote(x)
        , x
  )
}

# fix wrong shell quoting
fix_quoted_options <- function(x){
  x <- gsub("'(--?[[:alpha:]]+=)", "\\1'", x)
}
# 
# class Dict extends Object
# 
#     constructor: (pairs) ->
#         (@[key] = value for [key, value] in pairs)
# 
#     toString: () ->
#         atts = (k for k of @ when k not in ['constructor', 'toString'])
#         atts.sort()
#         '{' + (k + ': ' + @[k] for k in atts).join(',\n ') + '}'
# 

#' @export
print.docopt <- function(x, ...) {
    print(str(x, give.attr=FALSE))           # convenient shortcut
    invisible(x) 
}

context("Issues")

test_that("quoted arguments work (#2)", {
  doc <- "
  Usage:
  exampleScript <arg1>
  "
  opt <- docopt(doc, "\"quoted arg\"")
  expect_equal(opt$arg1, "quoted arg")
})


test_that("quoted arguments work (#4)", {
  doc <- 'Usage: do.R <dirname> [<other>...]'
  opt <- docopt(doc, "some_directory '--quoted test'", quoted_args=T
        )
  
  expect_equal(opt$other, "--quoted test")
  
})

test_that("multivalued options work (#8)",{
  "
Usage:
    install.r [-r repo]...

Options:
   -r=repo  Repository
" -> doc
  opt <- docopt(doc, "-r repo1 -r repo2")
  expect_equal(opt$r, c("repo1", "repo2"))
})


test_that("strings containing spaces are passed correctly (#11)", {
  "
  Usage: foo.R [-i <integers>]
  
  Options:
    -i <integers>, --integers=<integers>  Integers [default: 1]
  " -> doc
  opt <- docopt(doc, "-i ' c(1, 8)'")
  expect_equal(opt$integers, " c(1, 8)")
})

test_that("quoted options are ok (#19)",{
  '
Usage:
  style_files [--arg=<arg1>] <files>...

Options:
  --arg=<arg1>  Package where the style guide is stored [default: Arg1].

' -> doc
  
  arguments <- docopt::docopt(doc, "--arg='bla bla' f1")
  expect_equal(arguments$arg, "bla bla")
  expect_equal(arguments$files, "f1")
})

test_that("kebab case option to snake case",{
'
Usage: foo.R

Options:
  --do-the-thing=<dtt>  Do the Thing! [default: yeah].

' -> doc
  opt <- docopt::docopt(doc)
  expect_equal(names(opt), c("--do-the-thing", "do_the_thing"))
})

test_that("quotes inside options are preserved",{
  "style files.
Usage:
  style_files [--arg=<arg1>] <files>...

Options:
  --arg=<arg1>  Package where the style guide is stored [default: Arg1].

" -> doc
  
  # expected behavior
  opt = docopt(doc, c("--arg='tidyverse_style(scope= \"none\")'", "R/test.R"))
  expect_equal(opt$arg, "tidyverse_style(scope= \"none\")")
})

#####################

context('doc01')
doc <- 
'Usage: prog'

  
    test_that('parsing "" works',{
		#$ prog
		#{}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 0)
      expect_equivalent(res[NULL], list())
    })

    test_that('parsing "--xxx" works',{
		#$ prog --xxx
		#"user-error"

      expect_error(docopt(doc, '--xxx', strict=TRUE))
    })

#####################

context('doc02')
doc <- 
'Usage: prog [options]

Options: -a  All.'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-a": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-a"], list("-a" = FALSE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-a": true}
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-a"], list("-a" = TRUE))
    })

    test_that('parsing "-x" works',{
		#$ prog -x
		#"user-error"

      expect_error(docopt(doc, '-x', strict=TRUE))
    })

#####################

context('doc03')
doc <- 
'Usage: prog [options]

Options: --all  All.'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--all": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--all"], list("--all" = FALSE))
    })

    test_that('parsing "--all" works',{
		#$ prog --all
		#{"--all": true}
      res <- docopt(doc, '--all', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--all"], list("--all" = TRUE))
    })

    test_that('parsing "--xxx" works',{
		#$ prog --xxx
		#"user-error"

      expect_error(docopt(doc, '--xxx', strict=TRUE))
    })

#####################

context('doc04')
doc <- 
'Usage: prog [options]

Options: -v, --verbose  Verbose.'

  
    test_that('parsing "--verbose" works',{
		#$ prog --verbose
		#{"--verbose": true}
      res <- docopt(doc, '--verbose', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--verbose"], list("--verbose" = TRUE))
    })

    test_that('parsing "--ver" works',{
		#$ prog --ver
		#{"--verbose": true}
      res <- docopt(doc, '--ver', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--verbose"], list("--verbose" = TRUE))
    })

    test_that('parsing "-v" works',{
		#$ prog -v
		#{"--verbose": true}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--verbose"], list("--verbose" = TRUE))
    })

#####################

context('doc05')
doc <- 
'Usage: prog [options]

Options: -p PATH'

  
    test_that('parsing "-p home/" works',{
		#$ prog -p home/
		#{"-p": "home/"}
      res <- docopt(doc, '-p home/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-p"], list("-p" = "home/"))
    })

    test_that('parsing "-phome/" works',{
		#$ prog -phome/
		#{"-p": "home/"}
      res <- docopt(doc, '-phome/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-p"], list("-p" = "home/"))
    })

    test_that('parsing "-p" works',{
		#$ prog -p
		#"user-error"

      expect_error(docopt(doc, '-p', strict=TRUE))
    })

#####################

context('doc06')
doc <- 
'Usage: prog [options]

Options: --path <path>'

  
    test_that('parsing "--path home/" works',{
		#$ prog --path home/
		#{"--path": "home/"}
      res <- docopt(doc, '--path home/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "home/"))
    })

    test_that('parsing "--path=home/" works',{
		#$ prog --path=home/
		#{"--path": "home/"}
      res <- docopt(doc, '--path=home/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "home/"))
    })

    test_that('parsing "--pa home/" works',{
		#$ prog --pa home/
		#{"--path": "home/"}
      res <- docopt(doc, '--pa home/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "home/"))
    })

    test_that('parsing "--pa=home/" works',{
		#$ prog --pa=home/
		#{"--path": "home/"}
      res <- docopt(doc, '--pa=home/', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "home/"))
    })

    test_that('parsing "--path" works',{
		#$ prog --path
		#"user-error"

      expect_error(docopt(doc, '--path', strict=TRUE))
    })

#####################

context('doc07')
doc <- 
'Usage: prog [options]

Options: -p PATH, --path=<path>  Path to files.'

  
    test_that('parsing "-proot" works',{
		#$ prog -proot
		#{"--path": "root"}
      res <- docopt(doc, '-proot', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "root"))
    })

#####################

context('doc08')
doc <- 
'Usage: prog [options]

Options:    -p --path PATH  Path to files.'

  
    test_that('parsing "-p root" works',{
		#$ prog -p root
		#{"--path": "root"}
      res <- docopt(doc, '-p root', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "root"))
    })

    test_that('parsing "--path root" works',{
		#$ prog --path root
		#{"--path": "root"}
      res <- docopt(doc, '--path root', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "root"))
    })

#####################

context('doc09')
doc <- 
'Usage: prog [options]

Options:
 -p PATH  Path to files [default: ./]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-p": "./"}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-p"], list("-p" = "./"))
    })

    test_that('parsing "-phome" works',{
		#$ prog -phome
		#{"-p": "home"}
      res <- docopt(doc, '-phome', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-p"], list("-p" = "home"))
    })

#####################

context('doc10')
doc <- 
'UsAgE: prog [options]

OpTiOnS: --path=<files>  Path to files
                [dEfAuLt: /root]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--path": "/root"}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "/root"))
    })

    test_that('parsing "--path=home" works',{
		#$ prog --path=home
		#{"--path": "home"}
      res <- docopt(doc, '--path=home', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--path"], list("--path" = "home"))
    })

#####################

context('doc11')
doc <- 
'usage: prog [options]

options:
    -a        Add
    -r        Remote
    -m <msg>  Message'

  
    test_that('parsing "-a -r -m Hello" works',{
		#$ prog -a -r -m Hello
		#{"-a": true, "-r": true, "-m": "Hello"}
      res <- docopt(doc, '-a -r -m Hello', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-a", "-r", "-m")], list("-a" = TRUE, "-r" = TRUE, "-m" = "Hello"))
    })

    test_that('parsing "-armyourass" works',{
		#$ prog -armyourass
		#{"-a": true, "-r": true, "-m": "yourass"}
      res <- docopt(doc, '-armyourass', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-a", "-r", "-m")], list("-a" = TRUE, "-r" = TRUE, "-m" = "yourass"))
    })

    test_that('parsing "-a -r" works',{
		#$ prog -a -r
		#{"-a": true, "-r": true, "-m": null}
      res <- docopt(doc, '-a -r', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-a", "-r", "-m")], list("-a" = TRUE, "-r" = TRUE, "-m" = NULL))
    })

#####################

context('doc12')
doc <- 
'Usage: prog [options]

Options: --version
         --verbose'

  
    test_that('parsing "--version" works',{
		#$ prog --version
		#{"--version": true, "--verbose": false}
      res <- docopt(doc, '--version', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--version", "--verbose")], list("--version" = TRUE, "--verbose" = FALSE))
    })

    test_that('parsing "--verbose" works',{
		#$ prog --verbose
		#{"--version": false, "--verbose": true}
      res <- docopt(doc, '--verbose', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--version", "--verbose")], list("--version" = FALSE, "--verbose" = TRUE))
    })

    test_that('parsing "--ver" works',{
		#$ prog --ver
		#"user-error"

      expect_error(docopt(doc, '--ver', strict=TRUE))
    })

    test_that('parsing "--verb" works',{
		#$ prog --verb
		#{"--version": false, "--verbose": true}
      res <- docopt(doc, '--verb', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--version", "--verbose")], list("--version" = FALSE, "--verbose" = TRUE))
    })

#####################

context('doc13')
doc <- 
'usage: prog [-a -r -m <msg>]

options:
 -a        Add
 -r        Remote
 -m <msg>  Message'

  
    test_that('parsing "-armyourass" works',{
		#$ prog -armyourass
		#{"-a": true, "-r": true, "-m": "yourass"}
      res <- docopt(doc, '-armyourass', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-a", "-r", "-m")], list("-a" = TRUE, "-r" = TRUE, "-m" = "yourass"))
    })

#####################

context('doc14')
doc <- 
'usage: prog [-armmsg]

options: -a        Add
         -r        Remote
         -m <msg>  Message'

  
    test_that('parsing "-a -r -m Hello" works',{
		#$ prog -a -r -m Hello
		#{"-a": true, "-r": true, "-m": "Hello"}
      res <- docopt(doc, '-a -r -m Hello', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-a", "-r", "-m")], list("-a" = TRUE, "-r" = TRUE, "-m" = "Hello"))
    })

#####################

context('doc15')
doc <- 
'usage: prog -a -b

options:
 -a
 -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-a -b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-b -a" works',{
		#$ prog -b -a
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-b -a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#"user-error"

      expect_error(docopt(doc, '-a', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc16')
doc <- 
'usage: prog (-a -b)

options: -a
         -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-a -b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-b -a" works',{
		#$ prog -b -a
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-b -a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#"user-error"

      expect_error(docopt(doc, '-a', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc17')
doc <- 
'usage: prog [-a] -b

options: -a
 -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-a -b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-b -a" works',{
		#$ prog -b -a
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-b -a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#"user-error"

      expect_error(docopt(doc, '-a', strict=TRUE))
    })

    test_that('parsing "-b" works',{
		#$ prog -b
		#{"-a": false, "-b": true}
      res <- docopt(doc, '-b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = FALSE, "-b" = TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc18')
doc <- 
'usage: prog [(-a -b)]

options: -a
         -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-a -b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-b -a" works',{
		#$ prog -b -a
		#{"-a": true, "-b": true}
      res <- docopt(doc, '-b -a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = TRUE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#"user-error"

      expect_error(docopt(doc, '-a', strict=TRUE))
    })

    test_that('parsing "-b" works',{
		#$ prog -b
		#"user-error"

      expect_error(docopt(doc, '-b', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"-a": false, "-b": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = FALSE, "-b" = FALSE))
    })

#####################

context('doc19')
doc <- 
'usage: prog (-a|-b)

options: -a
         -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#"user-error"

      expect_error(docopt(doc, '-a -b', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-a": true, "-b": false}
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = FALSE))
    })

    test_that('parsing "-b" works',{
		#$ prog -b
		#{"-a": false, "-b": true}
      res <- docopt(doc, '-b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = FALSE, "-b" = TRUE))
    })

#####################

context('doc20')
doc <- 
'usage: prog [ -a | -b ]

options: -a
         -b'

  
    test_that('parsing "-a -b" works',{
		#$ prog -a -b
		#"user-error"

      expect_error(docopt(doc, '-a -b', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"-a": false, "-b": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = FALSE, "-b" = FALSE))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-a": true, "-b": false}
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = FALSE))
    })

    test_that('parsing "-b" works',{
		#$ prog -b
		#{"-a": false, "-b": true}
      res <- docopt(doc, '-b', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = FALSE, "-b" = TRUE))
    })

#####################

context('doc21')
doc <- 
'usage: prog <arg>'

  
    test_that('parsing "10" works',{
		#$ prog 10
		#{"<arg>": "10"}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<arg>"], list("<arg>" = "10"))
    })

    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#"user-error"

      expect_error(docopt(doc, '10 20', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc22')
doc <- 
'usage: prog [<arg>]'

  
    test_that('parsing "10" works',{
		#$ prog 10
		#{"<arg>": "10"}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<arg>"], list("<arg>" = "10"))
    })

    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#"user-error"

      expect_error(docopt(doc, '10 20', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"<arg>": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<arg>"], list("<arg>" = NULL))
    })

#####################

context('doc23')
doc <- 
'usage: prog <kind> <name> <type>'

  
    test_that('parsing "10 20 40" works',{
		#$ prog 10 20 40
		#{"<kind>": "10", "<name>": "20", "<type>": "40"}
      res <- docopt(doc, '10 20 40', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "<name>", "<type>")], list("<kind>" = "10", "<name>" = "20", "<type>" = "40"))
    })

    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#"user-error"

      expect_error(docopt(doc, '10 20', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc24')
doc <- 
'usage: prog <kind> [<name> <type>]'

  
    test_that('parsing "10 20 40" works',{
		#$ prog 10 20 40
		#{"<kind>": "10", "<name>": "20", "<type>": "40"}
      res <- docopt(doc, '10 20 40', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "<name>", "<type>")], list("<kind>" = "10", "<name>" = "20", "<type>" = "40"))
    })

    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"<kind>": "10", "<name>": "20", "<type>": null}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "<name>", "<type>")], list("<kind>" = "10", "<name>" = "20", "<type>" = NULL))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc25')
doc <- 
'usage: prog [<kind> | <name> <type>]'

  
    test_that('parsing "10 20 40" works',{
		#$ prog 10 20 40
		#"user-error"

      expect_error(docopt(doc, '10 20 40', strict=TRUE))
    })

    test_that('parsing "20 40" works',{
		#$ prog 20 40
		#{"<kind>": null, "<name>": "20", "<type>": "40"}
      res <- docopt(doc, '20 40', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "<name>", "<type>")], list("<kind>" = NULL, "<name>" = "20", "<type>" = "40"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"<kind>": null, "<name>": null, "<type>": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "<name>", "<type>")], list("<kind>" = NULL, "<name>" = NULL, "<type>" = NULL))
    })

#####################

context('doc26')
doc <- 
'usage: prog (<kind> --all | <name>)

options:
 --all'

  
    test_that('parsing "10 --all" works',{
		#$ prog 10 --all
		#{"<kind>": "10", "--all": true, "<name>": null}
      res <- docopt(doc, '10 --all', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "--all", "<name>")], list("<kind>" = "10", "--all" = TRUE, "<name>" = NULL))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"<kind>": null, "--all": false, "<name>": "10"}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("<kind>", "--all", "<name>")], list("<kind>" = NULL, "--all" = FALSE, "<name>" = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc27')
doc <- 
'usage: prog [<name> <name>]'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"<name>": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<name>"], list("<name>" = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"<name>": ["10"]}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<name>"], list("<name>" = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"<name>": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<name>"], list("<name>" = list()))
    })

#####################

context('doc28')
doc <- 
'usage: prog [(<name> <name>)]'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"<name>": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<name>"], list("<name>" = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#"user-error"

      expect_error(docopt(doc, '10', strict=TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"<name>": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<name>"], list("<name>" = list()))
    })

#####################

context('doc29')
doc <- 
'usage: prog NAME...'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"NAME": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": ["10"]}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

#####################

context('doc30')
doc <- 
'usage: prog [NAME]...'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"NAME": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": ["10"]}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"NAME": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = list()))
    })

#####################

context('doc31')
doc <- 
'usage: prog [NAME...]'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"NAME": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": ["10"]}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"NAME": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = list()))
    })

#####################

context('doc32')
doc <- 
'usage: prog [NAME [NAME ...]]'

  
    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"NAME": ["10", "20"]}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = c("10", "20")))
    })

    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": ["10"]}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = "10"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"NAME": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = list()))
    })

#####################

context('doc33')
doc <- 
'usage: prog (NAME | --foo NAME)

options: --foo'

  
    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": "10", "--foo": false}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("NAME", "--foo")], list(NAME = "10", "--foo" = FALSE))
    })

    test_that('parsing "--foo 10" works',{
		#$ prog --foo 10
		#{"NAME": "10", "--foo": true}
      res <- docopt(doc, '--foo 10', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("NAME", "--foo")], list(NAME = "10", "--foo" = TRUE))
    })

    test_that('parsing "--foo=10" works',{
		#$ prog --foo=10
		#"user-error"

      expect_error(docopt(doc, '--foo=10', strict=TRUE))
    })

#####################

context('doc34')
doc <- 
'usage: prog (NAME | --foo) [--bar | NAME]

options: --foo
options: --bar'

  
    test_that('parsing "10" works',{
		#$ prog 10
		#{"NAME": ["10"], "--foo": false, "--bar": false}
      res <- docopt(doc, '10', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("NAME", "--foo", "--bar")], list(NAME = "10", "--foo" = FALSE, "--bar" = FALSE))
    })

    test_that('parsing "10 20" works',{
		#$ prog 10 20
		#{"NAME": ["10", "20"], "--foo": false, "--bar": false}
      res <- docopt(doc, '10 20', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("NAME", "--foo", "--bar")], list(NAME = c("10", "20"), "--foo" = FALSE, "--bar" = FALSE))
    })

    test_that('parsing "--foo --bar" works',{
		#$ prog --foo --bar
		#{"NAME": [], "--foo": true, "--bar": true}
      res <- docopt(doc, '--foo --bar', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("NAME", "--foo", "--bar")], list(NAME = list(), "--foo" = TRUE, "--bar" = TRUE))
    })

#####################

context('doc35')
doc <- 
'Naval Fate.

Usage:
  prog ship new <name>...
  prog ship [<name>] move <x> <y> [--speed=<kn>]
  prog ship shoot <x> <y>
  prog mine (set|remove) <x> <y> [--moored|--drifting]
  prog -h | --help
  prog --version

Options:
  -h --help     Show this screen.
  --version     Show version.
  --speed=<kn>  Speed in knots [default: 10].
  --moored      Mored (anchored) mine.
  --drifting    Drifting mine.'

  
    test_that('parsing "ship Guardian move 150 300 --speed=20" works',{
		#$ prog ship Guardian move 150 300 --speed=20
		#{"--drifting": false, "--help": false, "--moored": false, "--speed": "20", "--version": false, "<name>": ["Guardian"], "<x>": "150", "<y>": "300", "mine": false, "move": true, "new": false, "remove": false, "set": false, "ship": true, "shoot": false}
      res <- docopt(doc, 'ship Guardian move 150 300 --speed=20', strict=TRUE)
      expect_equivalent(length(res), 15)
      expect_equivalent(res[c("--drifting", "--help", "--moored", "--speed", "--version","<name>", "<x>", "<y>", "mine", "move", "new", "remove", "set", "ship", "shoot")], list("--drifting" = FALSE, "--help" = FALSE, "--moored" = FALSE, "--speed" = "20", "--version" = FALSE, "<name>" = "Guardian", "<x>" = "150", "<y>" = "300", mine = FALSE, move = TRUE, new = FALSE, remove = FALSE, set = FALSE, ship = TRUE, shoot = FALSE))
    })

#####################

context('doc36')
doc <- 
'usage: prog --hello'

  
    test_that('parsing "--hello" works',{
		#$ prog --hello
		#{"--hello": true}
      res <- docopt(doc, '--hello', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = TRUE))
    })

#####################

context('doc37')
doc <- 
'usage: prog [--hello=<world>]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--hello": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = NULL))
    })

    test_that('parsing "--hello wrld" works',{
		#$ prog --hello wrld
		#{"--hello": "wrld"}
      res <- docopt(doc, '--hello wrld', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = "wrld"))
    })

#####################

context('doc38')
doc <- 
'usage: prog [-o]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-o": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = FALSE))
    })

    test_that('parsing "-o" works',{
		#$ prog -o
		#{"-o": true}
      res <- docopt(doc, '-o', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = TRUE))
    })

#####################

context('doc39')
doc <- 
'usage: prog [-opr]'

  
    test_that('parsing "-op" works',{
		#$ prog -op
		#{"-o": true, "-p": true, "-r": false}
      res <- docopt(doc, '-op', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-o", "-p", "-r")], list("-o" = TRUE, "-p" = TRUE, "-r" = FALSE))
    })

#####################

context('doc40')
doc <- 
'usage: prog --aabb | --aa'

  
    test_that('parsing "--aa" works',{
		#$ prog --aa
		#{"--aabb": false, "--aa": true}
      res <- docopt(doc, '--aa', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--aabb", "--aa")], list("--aabb" = FALSE, "--aa" = TRUE))
    })

#####################

context('doc41')
doc <- 
'Usage: prog -v'

  
    test_that('parsing "-v" works',{
		#$ prog -v
		#{"-v": true}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = TRUE))
    })

#####################

context('doc42')
doc <- 
'Usage: prog [-v -v]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-v": 0}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 0))
    })

    test_that('parsing "-v" works',{
		#$ prog -v
		#{"-v": 1}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 1))
    })

    test_that('parsing "-vv" works',{
		#$ prog -vv
		#{"-v": 2}
      res <- docopt(doc, '-vv', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 2))
    })

#####################

context('doc43')
doc <- 
'Usage: prog -v ...'

  
    test_that('parsing "" works',{
		#$ prog
		#"user-error"

      expect_error(docopt(doc, '', strict=TRUE))
    })

    test_that('parsing "-v" works',{
		#$ prog -v
		#{"-v": 1}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 1))
    })

    test_that('parsing "-vv" works',{
		#$ prog -vv
		#{"-v": 2}
      res <- docopt(doc, '-vv', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 2))
    })

    test_that('parsing "-vvvvvv" works',{
		#$ prog -vvvvvv
		#{"-v": 6}
      res <- docopt(doc, '-vvvvvv', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 6))
    })

#####################

context('doc44')
doc <- 
'Usage: prog [-v | -vv | -vvv]

This one is probably most readable user-friednly variant.'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-v": 0}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 0))
    })

    test_that('parsing "-v" works',{
		#$ prog -v
		#{"-v": 1}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 1))
    })

    test_that('parsing "-vv" works',{
		#$ prog -vv
		#{"-v": 2}
      res <- docopt(doc, '-vv', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-v"], list("-v" = 2))
    })

    test_that('parsing "-vvvv" works',{
		#$ prog -vvvv
		#"user-error"

      expect_error(docopt(doc, '-vvvv', strict=TRUE))
    })

#####################

context('doc45')
doc <- 
'usage: prog [--ver --ver]'
    test_that('parsing "--ver --ver" works',{
      skip("not implemented")
		#$ prog --ver --ver
		#{"--ver": 2}
      res <- docopt(doc, '--ver --ver', strict=TRUE)
      expect_equivalent(length(res), 1)
      skip_on_cran()
      expect_equivalent(res["--ver"], list("--ver" = 2))
    })

#####################

context('doc46')
doc <- 
'usage: prog [go]'

  
    test_that('parsing "go" works',{
		#$ prog go
		#{"go": true}
      res <- docopt(doc, 'go', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["go"], list(go = TRUE))
    })

#####################

context('doc47')
doc <- 
'usage: prog [go go]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"go": 0}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["go"], list(go = 0))
    })

    test_that('parsing "go" works',{
		#$ prog go
		#{"go": 1}
      skip("not implemented")
      res <- docopt(doc, 'go', strict=TRUE) 
      expect_equivalent(length(res), 1)
      expect_equivalent(res["go"], list(go = 1))
    })

    test_that('parsing "go go" works',{
		#$ prog go go
		#{"go": 2}
      skip("not implemented")
      res <- docopt(doc, 'go go', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["go"], list(go = 2))
    })

    test_that('parsing "go go go" works',{
		#$ prog go go go
		#"user-error"
      
      expect_error(docopt(doc, 'go go go', strict=TRUE))
    })

#####################

context('doc48')
doc <- 
'usage: prog go...'

  
    test_that('parsing "go go go go go" works',{
		#$ prog go go go go go
		#{"go": 5}
      skip("not implemented")
      res <- docopt(doc, 'go go go go go', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["go"], list(go = 5))
    })

    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-a": true, "-b": false}
      skip("not implemented")
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-a", "-b")], list("-a" = TRUE, "-b" = FALSE))
    })

    test_that('parsing "-aa" works',{
		#$ prog -aa
		#"user-error"

      expect_error(docopt(doc, '-aa', strict=TRUE))
    })

#####################

context('doc49')
doc <- 
'Usage: prog [options] A
Options:
    -q  Be quiet
    -v  Be verbose.'

  
    test_that('parsing "arg" works',{
		#$ prog arg
		#{"A": "arg", "-v": false, "-q": false}
      res <- docopt(doc, 'arg', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("A", "-v", "-q")], list(A = "arg", "-v" = FALSE, "-q" = FALSE))
    })

    test_that('parsing "-v arg" works',{
		#$ prog -v arg
		#{"A": "arg", "-v": true, "-q": false}
      res <- docopt(doc, '-v arg', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("A", "-v", "-q")], list(A = "arg", "-v" = TRUE, "-q" = FALSE))
    })

    test_that('parsing "-q arg" works',{
		#$ prog -q arg
		#{"A": "arg", "-v": false, "-q": true}
      res <- docopt(doc, '-q arg', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("A", "-v", "-q")], list(A = "arg", "-v" = FALSE, "-q" = TRUE))
    })

#####################

context('doc50')
doc <- 
'usage: prog [-]'

  
    test_that('parsing "-" works',{
		#$ prog -
		#{"-": true}
      res <- docopt(doc, '-', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-"], list("-" = TRUE))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"-": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-"], list("-" = FALSE))
    })

#####################

context('doc51')
doc <- 
'usage: prog [NAME [NAME ...]]'

  
    test_that('parsing "a b" works',{
		#$ prog a b
		#{"NAME": ["a", "b"]}
      res <- docopt(doc, 'a b', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = c("a", "b")))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"NAME": []}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["NAME"], list(NAME = list()))
    })

#####################

context('doc52')
doc <- 
'usage: prog [options]
options:
 -a        Add
 -m <msg>  Message'

  
    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-m": null, "-a": true}
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-m", "-a")], list("-m" = NULL, "-a" = TRUE))
    })

#####################

context('doc53')
doc <- 
'usage: prog --hello'

  
    test_that('parsing "--hello" works',{
		#$ prog --hello
		#{"--hello": true}
      res <- docopt(doc, '--hello', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = TRUE))
    })

#####################

context('doc54')
doc <- 
'usage: prog [--hello=<world>]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--hello": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = NULL))
    })

    test_that('parsing "--hello wrld" works',{
		#$ prog --hello wrld
		#{"--hello": "wrld"}
      res <- docopt(doc, '--hello wrld', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--hello"], list("--hello" = "wrld"))
    })

#####################

context('doc55')
doc <- 
'usage: prog [-o]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"-o": false}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = FALSE))
    })

    test_that('parsing "-o" works',{
		#$ prog -o
		#{"-o": true}
      res <- docopt(doc, '-o', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = TRUE))
    })

#####################

context('doc56')
doc <- 
'usage: prog [-opr]'

  
    test_that('parsing "-op" works',{
		#$ prog -op
		#{"-o": true, "-p": true, "-r": false}
      res <- docopt(doc, '-op', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("-o", "-p", "-r")], list("-o" = TRUE, "-p" = TRUE, "-r" = FALSE))
    })

#####################

context('doc57')
doc <- 
'usage: git [-v | --verbose]'

  
    test_that('parsing "-v" works',{
		#$ prog -v
		#{"-v": true, "--verbose": false}
      res <- docopt(doc, '-v', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("-v", "--verbose")], list("-v" = TRUE, "--verbose" = FALSE))
    })

#####################

context('doc58')
doc <- 
'usage: git remote [-v | --verbose]'

  
    test_that('parsing "remote -v" works',{
		#$ prog remote -v
		#{"remote": true, "-v": true, "--verbose": false}
      res <- docopt(doc, 'remote -v', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("remote", "-v", "--verbose")], list(remote = TRUE, "-v" = TRUE, "--verbose" = FALSE))
    })

#####################

context('doc59')
doc <- 
'usage: prog'

  
    test_that('parsing "" works',{
		#$ prog
		#{}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 0)
      expect_equivalent(res[NULL], list())
    })

#####################

context('doc60')
doc <- 
'usage: prog
           prog <a> <b>'

  
    test_that('parsing "1 2" works',{
		#$ prog 1 2
		#{"<a>": "1", "<b>": "2"}
      res <- docopt(doc, '1 2', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("<a>", "<b>")], list("<a>" = "1", "<b>" = "2"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"<a>": null, "<b>": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("<a>", "<b>")], list("<a>" = NULL, "<b>" = NULL))
    })

#####################

context('doc61')
doc <- 
'usage: prog <a> <b>
           prog'

  
    test_that('parsing "" works',{
		#$ prog
		#{"<a>": null, "<b>": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("<a>", "<b>")], list("<a>" = NULL, "<b>" = NULL))
    })

#####################

context('doc62')
doc <- 
'usage: prog [--file=<f>]'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--file": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--file"], list("--file" = NULL))
    })

#####################

context('doc63')
doc <- 
'usage: prog [--file=<f>]

options: --file <a>'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--file": null}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--file"], list("--file" = NULL))
    })

#####################

context('doc64')
doc <- 
'Usage: prog [-a <host:port>]

Options: -a, --address <host:port>  TCP address [default: localhost:6283].'

  
    test_that('parsing "" works',{
		#$ prog
		#{"--address": "localhost:6283"}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--address"], list("--address" = "localhost:6283"))
    })

#####################

context('doc65')
doc <- 
'usage: prog --long=<arg> ...'

  
    test_that('parsing "--long one" works',{
		#$ prog --long one
		#{"--long": ["one"]}
      res <- docopt(doc, '--long one', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--long"], list("--long" = "one"))
    })

    test_that('parsing "--long one --long two" works',{
		#$ prog --long one --long two
		#{"--long": ["one", "two"]}
      res <- docopt(doc, '--long one --long two', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--long"], list("--long" = c("one", "two")))
    })

#####################

context('doc66')
doc <- 
'usage: prog (go <direction> --speed=<km/h>)...'

  
    test_that('parsing "go left --speed=5  go right --speed=9" works',{
      skip("not implemented")
      
		#$ prog  go left --speed=5  go right --speed=9
		#{"go": 2, "<direction>": ["left", "right"], "--speed": ["5", "9"]}
      res <- docopt(doc, 'go left --speed=5  go right --speed=9', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("go", "<direction>", "--speed")], list(go = 2, "<direction>" = c("left", "right"), "--speed" = c("5", "9")))
    })

#####################

context('doc67')
doc <- 
'usage: prog [options] -a

options: -a'

    skip("not implemented")

    test_that('parsing "-a" works',{
		#$ prog -a
		#{"-a": true}
      res <- docopt(doc, '-a', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-a"], list("-a" = TRUE))
    })

#####################

context('doc68')
doc <- 
'usage: prog [-o <o>]...

options: -o <o>  [default: x]'

  
    test_that('parsing "-o this -o that" works',{
		#$ prog -o this -o that
		#{"-o": ["this", "that"]}
      res <- docopt(doc, '-o this -o that', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = c("this", "that")))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"-o": ["x"]}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = "x"))
    })

#####################

context('doc69')
doc <- 
'usage: prog [-o <o>]...

options: -o <o>  [default: x y]'

  
    test_that('parsing "-o this" works',{
		#$ prog -o this
		#{"-o": ["this"]}
      res <- docopt(doc, '-o this', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-o"], list("-o" = "this"))
    })

    test_that('parsing "" works',{
		#$ prog
		#{"-o": ["x", "y"]}
      res <- docopt(doc, '', strict=TRUE)
      expect_equivalent(length(res), 1)
      skip("not implemented")
      expect_equivalent(res["-o"], list("-o" = c("x", "y")))
    })

#####################

context('doc70')
doc <- 
'usage: prog -pPATH

options: -p PATH'

  
    test_that('parsing "-pHOME" works',{
		#$ prog -pHOME
		#{"-p": "HOME"}
      res <- docopt(doc, '-pHOME', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["-p"], list("-p" = "HOME"))
    })

#####################

context('doc71')
doc <- 
'Usage: foo (--xx=x|--yy=y)...'

  
    test_that('parsing "--xx=1 --yy=2" works',{
		#$ prog --xx=1 --yy=2
		#{"--xx": ["1"], "--yy": ["2"]}
      res <- docopt(doc, '--xx=1 --yy=2', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--xx", "--yy")], list("--xx" = "1", "--yy" = "2"))
    })

#####################

context('doc72')
doc <- 
'usage: prog [<input file>]'

  
    test_that('parsing "f.txt" works',{
		#$ prog f.txt
		#{"<input file>": "f.txt"}
      res <- docopt(doc, 'f.txt', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["<input file>"], list("<input file>" = "f.txt"))
    })

#####################

context('doc73')
doc <- 
'usage: prog [--input=<file name>]...'

  
    test_that('parsing "--input a.txt --input=b.txt" works',{
		#$ prog --input a.txt --input=b.txt
		#{"--input": ["a.txt", "b.txt"]}
      res <- docopt(doc, '--input a.txt --input=b.txt', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--input"], list("--input" = c("a.txt", "b.txt")))
    })

#####################

context('doc74')
doc <- 
'usage: prog good [options]
           prog fail [options]

options: --loglevel=N'

  
    test_that('parsing "fail --loglevel 5" works',{
		#$ prog fail --loglevel 5
		#{"--loglevel": "5", "fail": true, "good": false}
      res <- docopt(doc, 'fail --loglevel 5', strict=TRUE)
      expect_equivalent(length(res), 3)
      expect_equivalent(res[c("--loglevel", "fail", "good")], list("--loglevel" = "5", fail = TRUE, good = FALSE))
    })

#####################

context('doc75')
doc <- 
'usage:prog --foo'

  
    test_that('parsing "--foo" works',{
		#$ prog --foo
		#{"--foo": true}
      res <- docopt(doc, '--foo', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--foo"], list("--foo" = TRUE))
    })

#####################

context('doc76')
doc <- 
'PROGRAM USAGE: prog --foo'

  
    test_that('parsing "--foo" works',{
		#$ prog --foo
		#{"--foo": true}
      res <- docopt(doc, '--foo', strict=TRUE)
      expect_equivalent(length(res), 1)
      expect_equivalent(res["--foo"], list("--foo" = TRUE))
    })

#####################

context('doc77')
doc <- 
'Usage: prog --foo
           prog --bar
NOT PART OF SECTION'

  
    test_that('parsing "--foo" works',{
		#$ prog --foo
		#{"--foo": true, "--bar": false}
      res <- docopt(doc, '--foo', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--foo", "--bar")], list("--foo" = TRUE, "--bar" = FALSE))
    })

#####################

context('doc78')
doc <- 
'Usage:
 prog --foo
 prog --bar

NOT PART OF SECTION'

  
    test_that('parsing "--foo" works',{
		#$ prog --foo
		#{"--foo": true, "--bar": false}
      res <- docopt(doc, '--foo', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--foo", "--bar")], list("--foo" = TRUE, "--bar" = FALSE))
    })

#####################

context('doc79')
doc <- 
'Usage:
 prog --foo
 prog --bar
NOT PART OF SECTION'

  
    test_that('parsing "--foo" works',{
		#$ prog --foo
		#{"--foo": true, "--bar": false}
      res <- docopt(doc, '--foo', strict=TRUE)
      expect_equivalent(length(res), 2)
      expect_equivalent(res[c("--foo", "--bar")], list("--foo" = TRUE, "--bar" = FALSE))
    })

#####################

context('doc80')
doc <- 
'Usage: prog [options]

global options: --foo
local options: --baz
               --bar
other options:
 --egg
 --spam
-not-an-option-'

  
    test_that('parsing "--baz --egg" works',{
		#$ prog --baz --egg
		#{"--foo": false, "--baz": true, "--bar": false, "--egg": true, "--spam": false}
      res <- docopt(doc, '--baz --egg', strict=TRUE)
      skip("not implemented")
      expect_equivalent(length(res), 5)
      expect_equivalent(res[c("--foo", "--baz", "--bar", "--egg", "--spam")], list("--foo" = FALSE, "--baz" = TRUE, "--bar" = FALSE, "--egg" = TRUE, "--spam" = FALSE))
    })

context("Issues")

test_that("quoted arguments work (#2)", {
  doc <- "
  Usage:
  exampleScript <arg1>
  "
  opt <- docopt(doc, "\"quoted arg\"")
  expect_equal(opt$arg1, "quoted arg")
})


test_that("quoted arguments work (#4)", {
  doc <- 'Usage: do.R <dirname> [<other>...]'
  opt <- docopt(doc, "some_directory '--quoted test'", quoted_args=T
        )
  
  expect_equal(opt$other, "--quoted test")
  
})

test_that("multivalued options work (#8)",{
  "
Usage:
    install.r [-r repo]...

Options:
   -r=repo  Repository
" -> doc
  opt <- docopt(doc, "-r repo1 -r repo2")
  expect_equal(opt$r, c("repo1", "repo2"))
})

doc <- 
"Naval Fate.

lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text
lots of text lots of text lots of text lots of text lots of text lots of text lots of text

Usage:
  naval_fate ship new <name>...
  naval_fate ship <name> move <x> <y> [--speed=<kn>]
  naval_fate ship shoot <x> <y>
  naval_fate mine (set|remove) <x> <y> [--moored|--drifting]
  naval_fate -h | --help
  naval_fate --version

Options:
  -h --help     Show this screen.
  --version     Show version.
  --speed=<kn>  Speed in knots [default: 10].
  --moored      Moored (anchored) mine.
  --drifting    Drifting mine. 
"

expect_error(
  d <- docopt(doc)
)

parse_shorts <- function(tokens, optionlist){
  left <- substring(tokens$move(), 2)
  parsed <- list()
  while(nchar(left) > 0){
    r <- paste0("-", substr(left, 1, 1))
    left <- substring(left, 2)
    simular <- Filter( function(o){
                 !is.null(o$short) && substring(o$short, 1, 3) == r
               }
               , optionlist$options)
    if (length(simular) > 1){
      tokens$error(r, "is specified ambiguously ", length(simular), " times")
    }
    
    if (length(simular) < 1){
      o = Option(r, NULL)
      if (tokens$strict){
        o = Option(r, value=TRUE) # needed for version and help
      } else {
        optionlist$push(o)
      }
    } else {
      simular = tail(simular, 1)[[1]]
      o <- Option(simular$short, simular$long, simular$argcount, simular$value)
      value <- ""
      if (simular$argcount != 0){ 
        if (left == ""){
          if (tokens$current() %in% c("", "--"))
            tokens$error(o$short, "requires argument")
          value <- tokens$move()
        } else {
          value <- left
        }
        left = ""
      }
      if (tokens$strict){
        o$value <- if (value != "") value else TRUE 
      }
    }
    parsed <- c(parsed, o)
  }
  parsed
}
starts_with <- function(x, start){
  identical(str_sub(x, 1, nchar(start)), start)
}

# 
# 
# parse_long = (tokens, options) ->
parse_long <- function(tokens, optionlist){
  # using move, because it strips quotation (and current not)
  token <- tokens$move()
  m <- str_match(token, "(.*?)=(.*)")
  if (!any(is.na(m))){
    raw <- m[,2]
    value <- m[,3]
  } else {
    raw <- token
    value <- NULL
  }
  check <- if (tokens$strict) starts_with else identical
  simular <- Filter(function(o){
    (nchar(o$long) && check(o$long, raw))
  }, optionlist$options)
  if (length(simular) > 1){
    simular <- Filter(function(o){
      identical(o$long, raw)
    }, simular)
    if (length(simular) != 1){
      tokens$error(raw, " is specified ambigously")
    }
  }
  #     if simular.length < 1
  if (length(simular) < 1){
    argcount <- if (is.null(value)) 0 else 1
    o <- Option(NULL, raw, argcount)
    if (tokens$strict){
      o <- Option(NULL, raw, argcount, if (argcount > 0) value else TRUE)
    } else {
      optionlist$push(o)
    }
    return(list(o))
  }
  simular <- simular[[1]]
  o <- Option(simular$short, simular$long, simular$argcount, simular$value)
  if (o$argcount == 1){
    if (is.null(value)){
      if (tokens$current() == ""){
        tokens$error(o$name(), " requires argument")
      }
      value <- tokens$move()
    }
  } else if (!is.null(value)){
    tokens$error(o$name(), " must not have an argument")
  }
  o$value <- if (is.null(value) || identical(value, FALSE)) TRUE else value
  list(o)
}

parse_pattern <- function(src, optionlist){
  src <- gsub("([\\(\\)\\|]|\\[|\\]|\\.\\.\\.)", ' \\1 ', src)
  tokens <- Tokens(src, cat)
  result <- parse_expr(tokens, optionlist)
  if (tokens$current() != ''){
    stop("unexpected ending:'", tokens$join(" "),"'", call. = FALSE)
  }
  Required(result)
}

parse_expr <- function(tokens, optionlist){
  seq <- parse_seq(tokens, optionlist)
  if (tokens$current() != "|"){
    return(seq)
  }
  
  optional <- FALSE
  result <- if(length(seq)>1) list(Required(seq)) else seq
  if (length(seq) == 0) optional <- TRUE
  
  while(tokens$current() == "|"){
    tokens$move()
    seq <- parse_seq(tokens, optionlist)
    if (length(seq) == 0) optional <- TRUE    
    result <- c(result, if (length(seq)>1)list(Required(seq)) else seq)
  }
  
  if (length(result)>1){
    result <- list(Either(result))
  }
  
  if (optional){
    result <- list(Optional(result))
  }
  
  result
}

parse_seq <- function(tokens, optionlist){ 
# seq ::= ( atom [ '...' ] )* ;
  result <- list()
  while(!isTRUE(tokens$current() %in% c("", "]", ")", "|"))){
    atom <- parse_atom(tokens, optionlist)
    if (isTRUE(tokens$current() == '...')){
      atom <- OneOrMore(atom)
      tokens$move()
    }
    result <- c(result, atom)
  }
  result
}
 

parse_atom <- function(tokens, optionlist){
  # atom ::= '(' expr ')' | '[' expr ']' | '[' 'options' ']' | '--'
  #        | long | shorts | argument | command ;
  token <- tokens$current()
  result <- list()
  if (token == '('){
    tokens$move()
    result <- list(Required(parse_expr(tokens, optionlist)))
    if (tokens$move() != ")"){
      tokens$error("Unmatched '('")
    }
    result
  } else if (token == '['){
    tokens$move()
    if (tokens$current() == 'options'){
      result = list(Optional(list(AnyOptions())))
      tokens$move()
    } else {
      result <- list(Optional(parse_expr(tokens, optionlist)))
    }
    if (tokens$move() != "]"){
      tokens$error("Unmatched '['")
    }
    result
  } else if (substr(token, 1, 2) == '--' ){
    if (token == '--'){
      list(Command(tokens$move()))
    } else {
      parse_long(tokens, optionlist)
    }
  } else if (substr(token,1,1) == '-' && token != '-'){
    parse_shorts(tokens, optionlist)
  } else if (grepl("^<.+>$", token) || grepl("^[^a-z]*[A-Z]+[^a-z]*$", token)){
    list(Argument(tokens$move()))
  } else{
    #         [new Command tokens.move()]
    list(Command(tokens$move()))
  }
}

# 
# parse_args = (source, options) ->
parse_args <- function(src, optionlist){
#     tokens = new TokenStream source, DocoptExit
  QUOTED <- "^'(.*?)'$"
  cmdargs <- length(src) > 1 || any(str_detect(src, QUOTED))
  if (cmdargs){
    src <- sub(QUOTED, "\\1", src)
  }
  tokens <- Tokens(src, as_is = cmdargs)
  
  #browser()
#     #options = options.slice(0) # shallow copy, not sure if necessary
#     opts = []
  opts = list()
  #     while (token = tokens.current()) isnt null
  while ((token <- tokens$current()) != "")
    if (token == '--'){
        ## if token is '--' then this and the rest of the arguments
        ## are positional arguments.
        return(c(opts, lapply(tokens$tokens, function(x) Argument(NULL, x))))
    } else if (grepl("^--", token)){
      #         else if token[0...2] is '--'
      #             long = parse_long tokens, options
      #             opts = opts.concat long
      long <- parse_long(tokens, optionlist)
      opts <- c(opts, long)
    } else if (grepl("^-.+", token)){
      #         else if token[0] is '-' and token isnt '-'
      #             shorts = parse_shorts tokens, options
      #             opts = opts.concat shorts
      shorts = parse_shorts(tokens, optionlist)
      opts <- c(opts, shorts)
    } else {
      opts <- c(opts, Argument(NULL, tokens$move()))
    }
  return(opts)
}

parse_option <- function(description){
#         description = description.replace(/^\s*|\s*$/g, '')
  # strip whitespaces
  description <- str_trim(description)
#         [_, options,
#          description] = description.match(/(.*?)  (.*)/) ? [null, description, '']
  # split on first occurence of 2 consecutive spaces ('  ')
  m <- str_match(description, "(.*?)  (.*)")
  if (any(is.na(m))){
    options <- description
  } else {
  options <- m[,2]
  }
#         # replace ',' or '=' with ' '
#         options = options.replace /,|=/g, ' '
  options <- gsub(",|=", " ", options)
#         # set some defaults
  short <- NULL
  long <- NULL
  argcount <- 0 
  value <- FALSE
  for (s in strsplit(options, "\\s+")[[1]]){
    if (substring(s, 1, 2) == "--"){
      long <- s
    } else if (substring(s, 1,1) == '-'){
      short <- s
    } else {
      argcount <- 1
    }
  }
#         if argcount is 1
  if (argcount == 1){
    matched <- str_match(description, "(?i)\\[default:\\s+(.*)\\]")
    value <- matched[,2]
    if (is.na(value)) value <- NULL
  }
  Option(short, long, argcount, value)
#         new Option short, long, argcount, value
}

# parse_doc_options = (doc) ->
parse_doc_options <- function(doc){
  #     (Option.parse('-' + s) for s in doc.split(/^\s*-|\n\s*-/)[1..])
  opts <- str_split(doc, "(?i)(\\n|Options:)\\s*-")[[1]]
  opts <- tail(opts, -1)
  # OptionList(lapply(tail(unlist(str_split(doc, "(?i)^\\s*-|\\n\\s*-|Options:\\s*-")),-1), function(s){
  #   parse_option(paste0('-', s))
  # }))
  OptionList(lapply(opts, function(s){
    parse_option(paste0('-', s))
  }))
}

QUOTED <- "'(.*?)'"
DQUOTED <- "\"(.*?)\""

# utility function
store_ws <- function(x, invert=FALSE){
  if (invert){
    gsub("___", " ", x, fixed = TRUE)
  } else {
    gsub(" ", "___", x, fixed = TRUE)
  }
}

# replaces values with white spaces
ws_replace <- function(pattern, x){
#  pattern <- "'(.*?)'"
  m <- gregexpr(pattern, x)
  ms <- regmatches(x, m)
  ms <- lapply(ms, store_ws)
  regmatches(x, m) <- ms
  x
}

Tokens <- setRefClass( "Tokens"
   , fields=list( tokens="character"
                , error="function"
                , strict="logical"
                , defining=function(){!strict}
                )
   , methods=list(
     initialize = function(tokens=character(), error=stop, as_is=FALSE){
       if (as_is){
         .tokens <- tokens
       } else {
         # browser()
         # trimws
         .tokens <- gsub("^\\s+|\\s+$", "", tokens)
         
         if (length(.tokens)){
           .tokens <- ws_replace("(<.*?>)", .tokens)
           .tokens <- ws_replace(QUOTED, .tokens)
           .tokens <- ws_replace(DQUOTED, .tokens)
           .tokens <- strsplit(.tokens, "\\s+")[[1]]
           .tokens <- store_ws(.tokens, invert = TRUE)
           # remove quotation
           # .tokens <- gsub("^'(.*)'$", "\\1", .tokens)
           # .tokens <- gsub('^"(.*)"$', "\\1", .tokens)
         }
       }
       tokens <<- .tokens
       if (missing(error)){
         strict <<- TRUE
       } else {
         strict <<- FALSE
       }
       error <<- error
     },
     current = function(){
       if (length(tokens)){
         tokens[1]
        } else {
          ""
        }
     },
     shift = function(){
       h <- head(tokens, 1)
       tokens <<- tail(tokens, -1)
       if (length(h)) h else ""
     },
     move = function(){
       h <- head(tokens, 1)
       tokens <<- tail(tokens, -1)
       
       #remove optional quotes...
       h <- gsub("^'(.*)'$", "\\1", h)
       h <- gsub("='(.*)'$", "=\\1", h)
       
       h <- gsub('^"(.*)"$', "\\1", h)
       h <- gsub('="(.*)"$', "=\\1", h)
       
       if (length(h)) h else ""
     },
     #     toString: -> ([].slice.apply @).toString()
     toString = function(){
       tokens
     },
     show = function(){
       cat("Tokens:", toString())
     },
     # 
     #     join: (glue) -> ([].join.apply @, glue)
     join = function(glue){
       paste0(tokens, collapse=glue)
     }
  )
)

#' index tokens
#' 
#' index tokens
#' @keywords internal
setMethod("[",
          signature(x = "Tokens"),
          function (x, i, drop = TRUE) 
          {
            x$tokens[i]
          }
)

#' index tokens
#' 
#' index tokens
#' @keywords internal
setMethod("[<-",
          signature(x = "Tokens"),
          function (x, i, value) 
          {
            x$tokens[i] <- value
          }
)

#' to character
#' 
#' to character
#' @keywords internal
setMethod("as.character", signature(x="Tokens"), function(x, ...){x$tokens})


# # testing 1, 2, 3
# t <- Tokens(c("a", "b"))
# t$current()
# t$shift()
# t

str_extract <- function(text, pattern){
  
  m <- regexpr(pattern=pattern, text = text, perl = TRUE)
  rstart <- as.integer(m)
  rstop  <- rstart + attr(m, "match.length") - 1
  
  rstart[rstart < 0] <- 0
  rstop[rstop < 0] <- 0
  substr(text, rstart, rstop)
}

str_extract_all <- function(text, pattern){
  m_all <- gregexpr(pattern=pattern, text = text, perl=TRUE)
  lapply(seq_along(m_all), function(i){
    m <- m_all[[i]]
    rstart <- as.integer(m)
    rstop  <- rstart + attr(m, "match.length") - 1
    
    rstart[rstart < 0] <- 0
    rstop[rstop < 0] <- 0
    mapply(function(start, stop){
      s <- substr(text[[i]],start, stop)
      if (s == ''){
        character()
      } else {
        s
      }
    }
    , rstart, rstop)
  })
}

str_trim <- function(x){
  gsub("^\\s+|\\s+$","", x)
}

str_c <- function(x, ...){
  paste0(x, ...)
}

str_split <- function(string, pattern){
  strsplit(string, split = pattern, perl=TRUE)
}

str_detect <- function(string, pattern){
  grepl(pattern, string)
}

str_sub <- function(string, start=1L, stop=-1L){
  substr(string, start = start, stop = stop)
}

str_replace <- function(string, pattern, replacement){
  sub(pattern, replacement = replacement, x = string, perl = TRUE)
}

str_replace_all <- function(string, pattern, replacement){
  gsub(pattern, replacement = replacement, x = string, perl = TRUE)
}

str_match <- function(string, pattern){
  ms <- regexpr(pattern=pattern, text = string, perl = TRUE)
  ms_stop <- ms + attr(ms, "match.length") - 1
  cap_start <- attr(ms, "capture.start")
  cap_stop <- cap_start + attr(ms, "capture.length") - 1
  cap_n <- ncol(cap_start)
  m <- t(
    sapply(seq_along(string), function(i){
      s <- string[i]
      c( substr(s, ms[i], ms_stop[i])
       , sapply(seq_len(cap_n), function(j){
            substr(s, cap_start[i,j], cap_stop[i,j])
         })
       )
    })
  )
  is.na(m) <- nchar(m) == 0
  m
}

text = c("hallo", "test", "baadd")
pattern = "(\\w)\\1(.)"
# 
#str_extract(text = text, pattern = pattern)
# strextract_all(text = text, pattern = pattern)
string <- text
str_match(string, pattern)

library(rjson)
library(stringr)
library(whisker)

#TODO extract comments and introduce sections.

cases <- c(readLines("testcases.docopt"), "\n")
cases <- paste0(cases, collapse="\n")

# remove comments (TODO improve)
cases <- str_replace_all(cases, "#.+?\n", "")
cases <- str_replace_all(cases, ",\n", ",")
cases <- unlist(str_split(cases, "\nr"))

#case1 <- cases[1]

p_usage <- 'r?\\"\\"\\"(.*?)\\"\\"\\"\n'
p_test <- '^([^\n]+)\n(.+?)\n\n'
p_prog <- '\\$ prog([^\n]*)\n([^\n]*)\n'

i <- 1
cases <- lapply(cases, function(x){
  case <- list()
  # extract usage text
  case$usage <- str_trim(str_match(x, p_usage)[,2])
  case$name <- str_c("doc", str_pad(i, 2, pad="0"))
  i <<- i + 1
  
  tests <- str_match_all(x, p_prog)[[1]]

  if (length(tests)==0){
    case$failed <- str_replace_all(x, "(^|\n)", "\\1\t\t#")
    return(case)
  }
  
  case$tests <- apply(tests, 1, function(r){
    if (str_sub(r[3],1,1) == "{"){
      json <- fromJSON(r[3])
      output <- deparse(json, control="keepNA", width.cutoff = 500)
      error <- FALSE
    } else {
      json <- list()
      output <- r[3]
      error <- TRUE
    }
    test <- str_replace_all(str_trim(r[1]), "(^|\n)", "\\1\t\t#")
    keys <- deparse(names(json))
    list(test=test, args=str_trim(r[2]), output=output, error=error, keys=keys
        , len=length(json))
  })
  case
})



template <- "
{{#cases}}


#####################

context('{{{name}}}')
doc <- 
'{{{usage}}}'

  {{#failed}}
    #
    # TEST GENERATION FAILED
    #
{{{.}}}
    test_that('failed', stop())
  {{/failed}}
  {{#tests}}
    test_that('parsing \"{{{args}}}\" works',{
{{{test}}}
{{^error}}
      res <- docopt(doc, '{{{args}}}', strict=TRUE)
      expect_equivalent(length(res), {{{len}}})
      expect_equivalent(res[{{{keys}}}], {{{output}}})
{{/error}}
{{#error}}
      expect_error(docopt(doc, '{{{args}}}', strict=TRUE))
{{/error}}
    })
  {{/tests}}
{{/cases}}
"

writeLines(whisker.render(template), "../../tests/testthat/test_specs.R")

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Pattern.R
\name{as.character,Pattern-method}
\alias{as.character,Pattern-method}
\title{as.character.Pattern}
\usage{
\S4method{as.character}{Pattern}(x, ...)
}
\description{
as.character.Pattern
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/docopt.R
\name{docopt}
\alias{docopt}
\title{Parse \code{args} based on command-line interface described in \code{doc}.}
\usage{
docopt(
  doc,
  args = commandArgs(TRUE),
  name = NULL,
  help = TRUE,
  version = NULL,
  strict = FALSE,
  strip_names = !strict,
  quoted_args = !strict
)
}
\arguments{
\item{doc}{\code{character} vector with command line specification}

\item{args}{\code{character} vector of commandline arguments. 
If \code{args} is missing 
\code{commandArgs(trailingOnly=TRUE)} will be used.}

\item{name}{Currently not used}

\item{help}{\code{logical} should "-h" or "--help" generate a usage string?}

\item{version}{\code{character}. If supplied the option "-v" generates
the given version number and stops.}

\item{strict}{\code{logical} if \code{TRUE} docopt will conform to docopt.py 
in and output (\code{strip_names=FALSE} and \code{quoted_args=FALSE})}

\item{strip_names}{if \code{TRUE} it will remove dashes and angles from the 
resulting names and add these to the resulting list. 
Note that this is different from docopt standard!}

\item{quoted_args}{if \code{TRUE} it will accept quoted arguments. 
Note that this is different from docopt standard!}
}
\value{
named list with all parsed options, arguments and commands.
}
\description{
\code{docopt} creates your command-line interface based on its
description that you pass as \code{doc}. 
Such description can contain
--options, <positional-argument>, commands, which could be
[optional], (required), (mutually | exclusive) or repeated...
}
\examples{
"Usage: my_program.R [-hso FILE] [--quiet | --verbose] [INPUT ...]

-h --help    show this
-s --sorted  sorted output
-o FILE      specify output file [default: ./test.txt]
--quiet      print less text
--verbose    print more text" -> doc
docopt(doc, "-s --quiet")
}
\references{
\url{http://docopt.org},
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/docopt-package.R
\docType{package}
\name{docopt-package}
\alias{docopt-package}
\title{Docopt command line specification}
\description{
docopt helps you to define an interface for your command-line app, and
automatically generate a parser for it.
}
\details{
For more information see http://docopt.org
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/docopt/docopt.R}
  \item Report bugs at \url{https://github.com/docopt/docopt.R/issues}
}

}
\author{
\strong{Maintainer}: Edwin de Jonge \email{edwindjonge@gmail.com} (\href{https://orcid.org/0000-0002-6580-4718}{ORCID})

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tokens.R
\name{[,Tokens-method}
\alias{[,Tokens-method}
\title{index tokens}
\usage{
\S4method{[}{Tokens}(x, i, drop = TRUE)
}
\description{
index tokens
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tokens.R
\name{as.character,Tokens-method}
\alias{as.character,Tokens-method}
\title{to character}
\usage{
\S4method{as.character}{Tokens}(x, ...)
}
\description{
to character
}
\keyword{internal}
